package org.opensourcephysics.tuleja.doublependulum3d;

import org.opensourcephysics.numerics.*;

public interface DoublePendulumODE extends ODE {
   public void setPhi1(double phi1);
   public void setPhi2(double phi2);
   public void setW1(double w1);
   public void setW2(double w2);
   public void setT(double t);

   public void setL1(double L1);
   public void setL2(double L2);

   public double getPhi1();
   public double getPhi2();
   public double getW1();
   public double getW2();
   public double getT();

   public double getL1();
   public double getL2();
}