/*
 * put your module comment here
 * formatted with JxBeauty (c) johann.langhofer@nextra.at
 */


package  org.opensourcephysics.tuleja.gyroscope;


/**
 * put your documentation comment here
 */
public class Gyroscope
        implements RigidBodyODE {
    private double[] state = new double[] {
        1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
    };
    //...initial state {theta,phi,psi,thetaD,phiD,psiD,t}
    double I = 1;               //principal moments of inertia of the rotating body with respect to body-fixed frame
    double I2 = 2;
    double m = 1;               //the mass of the rotating rigid body
    double l = 0;               // distance from the center of mass of the rigid body to the fixed point of rotation
    double g = 9.8;             //gravity acceleration

    /**
     * put your documentation comment here
     * @return
     */
    public double[] getState () {
        return  state;
    }

    /**
     * put your documentation comment here
     * @param state
     * @param rates
     */
    public void getRate (double[] state, double[] rates) {
        double cosTheta, sinTheta;
        cosTheta = Math.cos(state[0]);
        sinTheta = Math.sin(state[0]);
        rates[3] = m*g*l*sinTheta/I + state[4]*((I - I2)*cosTheta*state[4] -
                I2*state[5])*sinTheta/I;
        rates[4] = -state[3]*((2*I - I2)*cosTheta*state[4] - I2*state[5])/(sinTheta*I);
        rates[5] = state[3]*(-I2*cosTheta/sinTheta*state[5] + state[4]*((2*I
                - I2)*cosTheta*cosTheta/sinTheta + I*sinTheta))/I;
        rates[0] = state[3];
        rates[1] = state[4];
        rates[2] = state[5];
        rates[6] = 1;
    }

    /**
     * put your documentation comment here
     * @param theta
     * @param phi
     * @param psi
     * @param thetaD
     * @param phiD
     * @param psiD
     * @param t
     */
    public void setIC (double theta, double phi, double psi, double thetaD,
            double phiD, double psiD, double t) {
        state[0] = theta;
        state[1] = phi;
        state[2] = psi;
        state[3] = thetaD;
        state[4] = phiD;
        state[5] = psiD;
        state[6] = t;
    }

    /**
     * put your documentation comment here
     * @param I
     * @param I2
     */
    public void setI (double I, double I2) {
        this.I = I;
        this.I2 = I2;
    }

    /**
     * put your documentation comment here
     * @param m
     */
    public void setM (double m) {
        this.m = m;
    }

    /**
     * put your documentation comment here
     * @param l
     */
    public void setL (double l) {
        this.l = l;
    }


    /**
     * put your documentation comment here
     * @return
     */
    public double getTheta () {
        return  state[0];
    }

    /**
     * put your documentation comment here
     * @return
     */
    public double getPhi () {
        return  state[1];
    }

    /**
     * put your documentation comment here
     * @return
     */
    public double getPsi () {
        return  state[2];
    }

    /**
     * put your documentation comment here
     * @return
     */
    public double getThetaD () {
        return  state[3];
    }

    /**
     * put your documentation comment here
     * @return
     */
    public double getPhiD () {
        return  state[4];
    }

    /**
     * put your documentation comment here
     * @return
     */
    public double getPsiD () {
        return  state[5];
    }

    /**
     * put your documentation comment here
     * @return
     */
    public double getT () {
        return  state[6];
    }
}



