package org.opensourcephysics.tuleja.gyroscope;

import org.opensourcephysics.numerics.*;

public interface RigidBodyODE extends ODE {
   public void setIC(double theta, double phi, double psi, double thetaD, double phiD, double psiD, double t);
   public void setI(double I, double I2);
   public void setM(double m);
   public void setL(double l);
   public double getPhi();
   public double getPsi();
   public double getTheta();
   public double getPhiD();
   public double getPsiD();
   public double getThetaD();
   public double getT();
}
